/** Rjbg */
package tk.mtantyukityuki.threeKingdoms.unit;

import tk.mtantyukityuki.threeKingdoms.model.*;
import tk.mtantyukityuki.threeKingdoms.unit.controller.*;
import tk.mtantyukityuki.threeKingdoms.unit.graphicsEngine.*;

import java.awt.*;

public class Army extends Creature {

	/** ̌R𗦂wB */
	Commander commander;

	int numberOfSoldier;	//m
	int numberOfHorse;	//n̐
	int numberOfArchery;	//|̐

	int kind;	// ށB(cRnRcƂ퍑qƂ)

	public static final int NORMAL = 0;		// ʏ탆jbg
	public static final int TAKEDA_TROOPS = 1;	// cRnRc

	static final int TACTICS_FIELD_SIZE_X = 16;
	static final int TACTICS_FIELD_SIZE_Y = 16;

	public Army(int x, int y, Board board, Direction direction,
			int nationality, Unit target, boolean auto, Commander commander) {
		super(x, y, board,  direction, nationality, target, auto);

		this.commander = commander;

		init();
	}

	public Army(int x, int y, Board board, Direction direction, int nationality,
			int kind, Unit target, boolean auto, Commander commander) {

		super(x, y, board,  direction, nationality, target, auto);

		this.commander = commander;
		this.kind = kind;

		init();
	}

	public int  getNumberOfSoldier() { return numberOfSoldier; }
	public int  getNumberOfHorse() { return numberOfHorse; }
	public int  getNumberOfArchery() { return numberOfArchery; }

	public int  getKind() { return kind; }

	public void setNumberOfSoldier(int number) {
		if (number > maxHP) {
			number = maxHP;
		}
		hp = numberOfSoldier = number;
	}

	public Commander getCommander() { return commander; }
	public void setCommander(Commander commander) { this.commander = commander; }

	public void init() {
		if (kind == TAKEDA_TROOPS) {
			name = "cRnRc";
		} else {
			name = "R";
		}
		hp = 3000;		//mB
		maxHP = 5000;	//ő啺mB

		maxSpeed = 2;
		movementPower = 0;

		numberOfSoldier = hp;	//m
		numberOfHorse	= 500;	//n̐
		numberOfArchery = 700;	//|̐
	}

	public void run() {

		// ܂Ă邩ǂBłꍇɂ͑IB
		if (!checkExistence()) {
			remove();
			return;
		}

		// cԂȂ΁AȂɂ΂悢ȔfB
		if (auto)
			selfJudge();

		// ړB
		move();

	}


	/** ̃jbgview(R|[lg)
	ǂ̂悤ɕ`悷邩w肷邽߂̃_ufBXpb`ȃ\bhB*/
	public void show(Graphics g, int x, int y,
			UnitGraphicsEngine uge, Component view, Direction direction) {
		uge.show(g, x,y, this, view, direction);
	}

	/** ̃jbgview(R|[lg)ŃNbNꂽƂ
	ǂ̂悤ȓ邩̃_ufBXpb`ȃ\bhB*/
	public void clicked(UnitController controller) {
		controller.clicked(this);
	}

	protected void move() {

		// ~ĂƂ߂oĂȂ΁AƂĂ݂B
		if (walking) {

			movementPower += (maxSpeed*4);

			// ړ͂\ɂ܂Ă̂ȂA܂XNEFA甲oB
			if (board.getGround(x,y).getRestraint(direction) <= movementPower) {

				movementPower = 0;


				int destX = x + direction.getNextX();
				int destY = y + direction.getNextY();

				int oldX = x;
				int oldY = y;

				if (board.moveCreature(this, destX, destY)) {
					// ړɐB
					fireMoved(oldX, oldY);
				} else {
					// ړɎsB
					// OɓG邩Ȃ
					Army frontArmy = (Army)board.getCreature(destX, destY);

					if (checkEnemy(frontArmy)) {

						attack(frontArmy);
					}
				}

			}
		}


	}


	public void frontMove() {

		int destX = x + direction.getNextX();
		int destY = y + direction.getNextY();

		int oldX = x;
		int oldY = y;

		if (board.moveCreature(this, destX, destY)) {
			// ړɐB
			fireMoved(oldX, oldY);
		}
	}
	public void turn() {
		selfJudge();
	}

	/** 쐬郁\bhB */
	public void makeTacticsField( Army frontArmy ) {

	}
	/** Ƃė^ꂽmɂU */
	void attack(Army enemy) {

		Direction attackedDirection = new Direction( direction );

		// GUB
		attackedDirection.calculateDirectionStoD(x, y,  enemy.getX(), enemy.getY());
		enemy.attacked( getOffensivePower(attackedDirection), attackedDirection );

		// G甽B
		attackedDirection.calculateDirectionStoD( enemy.getX(), enemy.getY(), x, y );
		this.attacked( enemy.getOffensivePower(attackedDirection), attackedDirection );

	}

	/** U͂Zo郋[`B
	m̂uÚvuݑ́vú̗vupvɂċ߂ */
	public int getOffensivePower(Direction attackedDirection) {

		int retOffensivePower =
			board.getGround(x,y).getOffensivePower(attackedDirection) + (hp>>2);

		switch ( direction.getRelativeDirection(attackedDirection) ) {
			case Direction.UP:
				retOffensivePower += (0);
				break;

			case Direction.LEFT:
				retOffensivePower += (0);
				break;

			case Direction.RIGHT:
				retOffensivePower += (0);
				break;

			case Direction.DOWN:
				retOffensivePower += 0;
				break;
		}
		return retOffensivePower;
	}

	/** h͂Zo郋[`B
	m̂uh́vuݑ́vupvɂċ߂ */
	public int getDefensivePower(Direction attackedDirection) {

		int retDefensivePower =
				board.getGround(x,y).getDefensivePower(attackedDirection) + (hp>>3);

		switch ( direction.getRelativeDirection(attackedDirection) ) {
			case Direction.UP:
				retDefensivePower += 0;
				break;

			case Direction.LEFT:
				retDefensivePower += (0);
				break;

			case Direction.RIGHT:
				retDefensivePower += (0);
				break;

			case Direction.DOWN:
				retDefensivePower += (0);
				break;
		}

		return retDefensivePower;
	}


	/** g̍U͈͂ɓG邩ǂ𔻒f郋[` */
	public Soldier searchEnemy() {

		Soldier enemy = null;
		Direction tempDirection = new Direction(direction);
		int destX = x;
		int destY = y;

		destX += tempDirection.getNextX();
		destY += tempDirection.getNextY();

		enemy = (Soldier)board.getCreature(destX, destY);
		if ( !checkEnemy(enemy) ) {

			tempDirection.leftTurn();
			destX += tempDirection.getNextX();
			destY += tempDirection.getNextY();

			enemy = (Soldier)board.getCreature(destX, destY);
			if ( !checkEnemy(enemy) ) {

				tempDirection.contraryTurn();
				destX += (tempDirection.getNextX() * 2);
				destY += (tempDirection.getNextY() * 2);

				enemy = (Soldier)board.getCreature(destX, destY);
				if ( !checkEnemy(enemy) )
					enemy = null;
			}
		}

		return enemy;
	}


	/** GUꂽƂɌĂяo郋[`B */
	public void attacked(int damage, Direction attackedDirection) {

		// ǂꂭ炢̃_[W󂯂B
		damage -= getDefensivePower(attackedDirection);
		// ̃_[W}CiXɂȂA0ɕ␮B
		if (0 < damage) {
			hp -= damage;
			if (0 > hp) {
				hp = 0;
			}
			numberOfSoldier = hp;
		}

	}

}
