package tk.mtantyukityuki.threeKingdoms.unit;

import tk.mtantyukityuki.threeKingdoms.model.*;
import tk.mtantyukityuki.threeKingdoms.unit.controller.*;
import tk.mtantyukityuki.threeKingdoms.unit.graphicsEngine.*;

import java.awt.*;

public class Slope extends Ground {



	public Slope(int x, int y, Board board, int groundKind) {
		super(x,y, board, null, 0);

		this.groundKind = groundKind;
		name = "Ζ";
	}

	public Slope(int x, int y, Board board, Direction direction, int groundKind) {
		super(x,y, board, direction, 0);

		this.groundKind = groundKind;
		name = "Ζ";
	}


	/** ̒n`ƁA̒n`̏ɂzʉ߂̂ɂ́Aǂ̂炢̈ړ͂KvƂ邩B */
	public int getRestraint(Direction direction) {

		int length;

		/*
		 * XNEFAӂɕsɐi񂾏ꍇƁAΊpɕsɐi񂾏ꍇ̋̕␳B
		 * ӂɕsɐi񂾏ꍇ̋10ƂAΊpɕsɐi񂾏ꍇ̋14ƂB
		 * (1:1.41421356)
		 */
		switch (direction.getDirection()) {
			case Direction.UP_RIGHT :
			case Direction.UP_LEFT :
			case Direction.DOWN_RIGHT :
			case Direction.DOWN_LEFT :
				length = 14;
			default :
				length = 10;
		}

		if (structure != null) {

			return (structure.getRestraint(direction) * length);
		} else {
			return (getGroundRestraint(direction) * length);
		}
	}

	/** ̒n`ʉ߂̂ɂ́Aǂ̂炢̈ړ͂KvƂ邩B */
	public int getGroundRestraint(Direction direction) {

		int retRestraint;

		switch (groundKind) {
			case PLAIN_LAND:
				retRestraint = 2;
				break;
			case HILL_LAND:
			case LOW_LAND:
				retRestraint = 3;
				break;
			case HIGH_LAND:
			case SWAMP:
				retRestraint = 4;
				break;
			case LOW_MOUNTAIN:
			case SHALLOW_WATER:
				retRestraint = 5;
				break;
			case DEEP_WATER:
				retRestraint = 6;
				break;
			default:
				retRestraint = 4;
				break;
		}

		return retRestraint;
	}

	public int getOffensivePower(Direction attackedDirection) {
		if (structure != null) {
			return (groundKind + structure.getOffensivePower(attackedDirection));
		} else {
			return groundKind;
		}
	}
	public int getDefensivePower(Direction attackedDirection) {
		if (structure != null) {
			return (groundKind + structure.getDefensivePower(attackedDirection));
		} else {
			return groundKind;
		}
	}


	public void show(Graphics g, int x, int y,
			UnitGraphicsEngine uge, Component view, Direction direction) {
		uge.show(g, x,y, this, view, direction);
	}
}

