package tk.mtantyukityuki.threeKingdoms.unit;

import tk.mtantyukityuki.threeKingdoms.model.*;
import tk.mtantyukityuki.threeKingdoms.unit.controller.*;
import tk.mtantyukityuki.threeKingdoms.unit.graphicsEngine.*;

import java.awt.*;

public abstract class Soldier extends Creature {

	/** ÚB */
	int offensivePower;
	/** h́B */
	int defensivePower;

	/** UXs[h킵܂B
	UXs[hƂ͈̂莞ԈȓɉUł邩킷lłB
	̓Iɗ΁A}VK͂̐lAΓe͒ႭȂ܂B*/
	int attackSpeed;

	/** UXs[h݂ǂ̂炢܂킵܂B
	̐ll(݂20)ɂƁAU͂߂܂B*/
	int attackSpeedPower;

	/** Ĺulv́A̒萔肵܂B*/
	static final int ATTACK_TIMING = 20;

	/** ōxB */
	int maxSpeed;
	/** xB */
	int acceleration;

	/** ݑxB */
	int presentSpeed;

	/** ړ݂͂ǂ̂炢܂Ă邩킵܂B
	ejbg1^[ƂɁAݑx(presentSpeed)ɉړ͂
	܂Ă܂B
	܂n`NX⌚zNXɂ́A
	̏ꏊ甲o߂ɕKvȐlݒ肳Ă܂B
	ړ͂A̔ôɕKvȐl܂΁A
	jbg͂̃}XɐiނƂł܂B*/
	int movementPower;

	public int getPresentSpeed() { return presentSpeed; }

	public Soldier(int x, int y, Board tacticsField, Direction direction, int nationality) {
		super(x, y, tacticsField,  direction, nationality);

		walking = true;

		this.target = null;
		this.auto = false;

		init();
	}
	public Soldier(int x, int y, Board tacticsField, Direction direction, int nationality, Unit target, boolean auto) {
		super(x, y, tacticsField,  direction, nationality, target, auto);

		walking = true;

		this.target = target;
		this.auto = auto;

		init();
	}

	public void init() {
		hp = 100;	//m100ɐݒB
		maxHP = 100;	//̃NX̍ő啺m100ɁB

		offensivePower = 2;
		defensivePower = 2;

		presentSpeed = 0;
		maxSpeed = 2;
		acceleration = 1;

		attackSpeed = 5;

		movementPower = 0;
		attackSpeedPower = 0;
	}

	public void run() {

		// ܂Ă邩ǂBłꍇɂ͑IB
		if (!checkExistence()) {
			remove();
			return;
		}

		// cԂȂ΁AȂɂ΂悢ȔfB
		if (auto)
			selfJudge();

		// ~ĂƂ߂oĂȂ΁AƂĂ݂B
		if (walking)
			move();

		// UXs[h\ɂ܂Ă΁AGčUJnB
		if (ATTACK_TIMING <= (attackSpeedPower += attackSpeed) ) {
			Soldier enemy = searchEnemy();

			// U͈͓ɓG邩H
			if (enemy != null) {
				attack(enemy);		// ΍UA
				attackSpeedPower = 0;	// ~ςꂽUXs[h0ɁB

			// ݑxCB
			if (--presentSpeed < 0)
				presentSpeed = 0;

			}
			else
				attackSpeedPower = ATTACK_TIMING;
		}
	}

	public void show(Graphics g, int x, int y, UnitGraphicsEngine uge, Component view, Direction direction) {
		uge.show(g, x,y, this, view, direction);
	}

	protected void move() {


		// xɉăjbg̈ړ͂𑝂₷B(ނ߂ɂ́A̒n`ɉړ͂KvB)
		if (0 >= presentSpeed)
			movementPower += acceleration;
		else
			movementPower += presentSpeed;

		// ړ͂\ɂ܂Ă̂ȂA܂XNEFA甲oB
		if (board.getGround(x,y).getRestraint(direction) < movementPower ) {

			int destX = direction.getNextX() + x;
			int destY = direction.getNextY() + y;

			if ( board.moveCreature( this, destX, destY ) ) {
				// ړɐB
				// ݑxCB
				if ( (presentSpeed += acceleration) > maxSpeed)
					presentSpeed = maxSpeed;

			}
			else {
			// ړɎsB

				// Oɕm邩Ȃ
				Soldier frontSoldier = (Soldier)board.getCreature(destX,destY);

				if (frontSoldier != null) {
					if ( direction.getDirection() == frontSoldier.getDirection().getDirection() ) {
						if ( presentSpeed > frontSoldier.getPresentSpeed() )
							presentSpeed = frontSoldier.getPresentSpeed();
					}
					else {
						presentSpeed = 0;
					}
				}
				else {
					presentSpeed = 0;
				}
			}

		}
	}

	/** Ƃė^ꂽmɂU */
	void attack(Soldier enemy) {

		Direction attackedDirection = new Direction( direction );

		// GUB
		attackedDirection.calculateDirectionStoD(x, y,  enemy.getX(), enemy.getY());
		enemy.attacked( getOffensivePower(attackedDirection), attackedDirection );

		// G甽B
		attackedDirection.calculateDirectionStoD( enemy.getX(), enemy.getY(), x, y );
		this.attacked( enemy.getOffensivePower(attackedDirection), attackedDirection );

	}

	/** U͂Zo郋[`Bm̂uÚvuݑ́vú̗vupvɂċ߂ */
	public int getOffensivePower(Direction attackedDirection) {

		int retOffensivePower = offensivePower + board.getGround(x,y).getOffensivePower(attackedDirection) + (hp>>2);

		switch ( direction.getRelativeDirection( attackedDirection ) ) {
			case Direction.UP:
				retOffensivePower += (presentSpeed + 3);
				break;

			case Direction.LEFT:
				retOffensivePower += (presentSpeed + 2);
				break;

			case Direction.RIGHT:
				retOffensivePower += (presentSpeed + 1);
				break;

			case Direction.DOWN:
				retOffensivePower += presentSpeed;
				break;
		}
		return retOffensivePower;
	}

	/** h͂Zo郋[`Bm̂uh́vuݑ́vupvɂċ߂ */
	public int getDefensivePower(Direction attackedDirection) {

		int retDefensivePower = defensivePower + board.getGround(x,y).getDefensivePower(attackedDirection) + (hp>>3);

		switch ( direction.getRelativeDirection( attackedDirection ) ) {
			case Direction.UP:
				retDefensivePower += presentSpeed;
				break;

			case Direction.LEFT:
				retDefensivePower += (presentSpeed + 1);
				break;

			case Direction.RIGHT:
				retDefensivePower += (presentSpeed + 2);
				break;

			case Direction.DOWN:
				retDefensivePower += (presentSpeed + 3);
				break;
		}

		return retDefensivePower;
	}


	/** g̍U͈͂ɓG邩ǂ𔻒f郋[` */
	public Soldier searchEnemy() {

		Soldier enemy = null;
		Direction tempDirection = new Direction( direction );
		int destX = x;
		int destY = y;

		destX += tempDirection.getNextX();
		destY += tempDirection.getNextY();

		enemy = (Soldier)board.getCreature(destX, destY);
		if ( !checkEnemy(enemy) ) {

			tempDirection.leftTurn();
			destX += tempDirection.getNextX();
			destY += tempDirection.getNextY();

			enemy = (Soldier)board.getCreature(destX, destY);
			if ( !checkEnemy(enemy) ) {

				tempDirection.contraryTurn();
				destX += ( tempDirection.getNextX() * 2 );
				destY += ( tempDirection.getNextY() * 2 );

				enemy = (Soldier)board.getCreature(destX, destY);
				if ( !checkEnemy(enemy) )
					enemy = null;
			}
		}

		return enemy;
	}


	/** GUꂽƂɌĂяo郋[`B */
	public void attacked(int damage, Direction attackedDirection) {

		// ǂꂭ炢̃_[W󂯂B
		damage -= getDefensivePower(attackedDirection);
		// ̃_[W}CiXɂȂA0ɕ␮B
		if (0 < damage)
			hp -= damage;

	}



}
