/**
 * ss̏\ComponentB
 */
package tk.mtantyukityuki.threeKingdoms.view.swing;

import tk.mtantyukityuki.threeKingdoms.model.*;
import tk.mtantyukityuki.threeKingdoms.unit.*;
import tk.mtantyukityuki.threeKingdoms.unit.controller.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.*;

import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;


public class CityViewer extends JComponent implements UnitListener {


	static Integer diarogLayer = new Integer(3);

	City city;

	JLabel civilian;	// s
	JLabel artisan;		// El
	JLabel soldier;		// m
	JLabel conscript;	// \l

	JLabel weapon;
	JLabel horse;
	JLabel archery;

	static Icon artisanIcon;
	static Icon weaponIcon;
	static Icon soldierIcon;
	static Icon horseIcon;
	static Icon archeryIcon;

	JSlider conscriptSlider;
	JSlider artisanSlider;

	public CityViewer(City city) {


		CityViewerListener cityViewerListener = new CityViewerListener();
		this.city = city;


		// NX[_[ƁAToolKit̎擾B
		ClassLoader cl = this.getClass().getClassLoader();

		// NX[_[𗘗pgift@C̃oCif[^ǂ݂݁A
		// Toolkig𗘗pāÃoCif[^ƂImageIuWFNg쐬B
		artisanIcon = new ImageIcon(cl.getResource("resources/artisan.gif"));
		weaponIcon = new ImageIcon(cl.getResource("resources/weapon.gif"));
		soldierIcon = new ImageIcon(cl.getResource("resources/soldier.gif"));
		horseIcon = new ImageIcon(cl.getResource("resources/horse.gif"));
		archeryIcon = new ImageIcon(cl.getResource("resources/archery.gif"));


		civilian = new JLabel("", SwingConstants.CENTER);
		artisan = new JLabel("", SwingConstants.CENTER);
		soldier = new JLabel("", SwingConstants.CENTER);
		conscript = new JLabel("", SwingConstants.CENTER);

		weapon = new JLabel("", weaponIcon, SwingConstants.CENTER);
		horse = new JLabel("", horseIcon, SwingConstants.CENTER);
		archery = new JLabel("", archeryIcon, SwingConstants.CENTER);


		// s:Elӂ킯XC_[̍쐬B
		artisanSlider = new JSlider(0, 0, 0);
		artisanSlider.addChangeListener( cityViewerListener );

		// s:mӂ킯XC_[̍쐬B
		conscriptSlider = new JSlider(0, 0, 0);
		conscriptSlider.addChangeListener( cityViewerListener );

		JPanel populationPanel = new JPanel();	// sEl╺mA̐U蕪̂߂Panel
		JPanel weaponPanel = new JPanel();	// E|EnȂǂ̐\Panel

		setLayout( new GridLayout(2, 1) );
		add(populationPanel);
		add(weaponPanel);


		// Elӂ킯{^̍쐬B
		JButton b = new JButton( artisanIcon );
		b.setRequestFocusEnabled(false);

		b.setToolTipText("̐䗦ύX");
		b.addActionListener( cityViewerListener );
		b.setActionCommand("artisanPercent");
		b.setMnemonic( KeyEvent.VK_W );

		populationPanel.setLayout( new GridLayout(2, 6) );
		populationPanel.add( new JLabel("s") );
		populationPanel.add(civilian);
		populationPanel.add(artisanSlider);
		populationPanel.add( new JLabel("El") );
		populationPanel.add(artisan);
		populationPanel.add( b );


		// R{^̍쐬B
		b = new JButton( soldierIcon );
		b.setRequestFocusEnabled(false);

		b.setToolTipText("R쐬");
		b.addActionListener( cityViewerListener );
		b.setActionCommand("makeArmy");
		b.setMnemonic( KeyEvent.VK_A );

		populationPanel.add( new JLabel("\l") );
		populationPanel.add(conscript);
		populationPanel.add(conscriptSlider);
		populationPanel.add( new JLabel("m") );
		populationPanel.add(soldier);
		populationPanel.add( b );

		weaponPanel.setLayout( new FlowLayout() );
		weaponPanel.add(weapon);
		weaponPanel.add(horse);
		weaponPanel.add(archery);

		updateData();

		city.addUnitListener(this);
	}


	/**
	 * `悷ssf[^ŐV̏Ԃɂ郁\bhB
	 */
	void updateData() {
		Integer civilianNumber = new Integer(city.getCivilian());
		Integer artisanNumber = new Integer(city.getArtisan());
		Integer soldierNumber = new Integer(city.getSoldier());
		Integer conscriptNumber;

		Integer weaponNumber = new Integer(city.getWeapon());
		Integer horseNumber = new Integer(city.getHorse());
		Integer archeryNumber = new Integer(city.getArchery());

		if ( civilianNumber.intValue() > weaponNumber.intValue() ) {
			conscriptNumber = new Integer( weaponNumber.intValue() );
		} else {
			conscriptNumber = new Integer( civilianNumber.intValue() );
		}

		civilian.setText( civilianNumber.toString() );
		artisan.setText( artisanNumber.toString() );
		soldier.setText( soldierNumber.toString() );
		conscript.setText( conscriptNumber.toString() );

		weapon.setText( weaponNumber.toString() );
		horse.setText( horseNumber.toString() );
		archery.setText( archeryNumber.toString() );

		// s:Elӂ킯XC_[B
		artisanSlider.getModel().setRangeProperties(
			city.getCivilian(), 0, 0, city.getCivilian() + city.getArtisan(), false );

		// \v:mӂ킯XC_[B
		conscriptSlider.getModel().setRangeProperties(
			conscriptNumber.intValue(), 0, 0, conscriptNumber.intValue() + city.getSoldier(), false );
	}

	public void stateChanged(UnitEvent unitEvent) {
		updateData();
		repaint();
	}
	public void moved(UnitEvent unitEvent) {
		updateData();
		repaint();
	}

	class CityViewerListener implements ChangeListener, ActionListener {
		public void stateChanged(ChangeEvent e) {
			JSlider slider = (JSlider)e.getSource();
			if ( slider == artisanSlider ) {
				Integer civilianNumber = new Integer( slider.getValue() );
				Integer artisanNumber = new Integer( slider.getMaximum() - slider.getValue() );

				civilian.setText( civilianNumber.toString() );
				artisan.setText( artisanNumber.toString() );

				city.setCivilian( civilianNumber.intValue() );
				city.setArtisan( artisanNumber.intValue() );
			}
			else if ( slider == conscriptSlider ) {
				Integer conscriptNumber = new Integer( slider.getValue() );
				Integer soldierNumber = new Integer( slider.getMaximum() - slider.getValue() );

				conscript.setText( conscriptNumber.toString() );
				soldier.setText( soldierNumber.toString() );

				int subtractionSoldier = soldierNumber.intValue() - city.getSoldier();

				city.setCivilian( city.getCivilian() - subtractionSoldier );
				city.setWeapon( city.getWeapon() - subtractionSoldier );
				city.setSoldier( soldierNumber.intValue() );
			}
		}
		public void actionPerformed(ActionEvent e) {
			if ( e.getActionCommand().equals("makeArmy") ) {
				// RҐ_CAO\B
				WindowsManager.getInstance().createMakeArmyDialog(
					city, diarogLayer, 30, 30, 350, 150 );
			}
			else if ( e.getActionCommand().equals("artisanPercent") ) {
				WindowsManager.getInstance().createArtisanDialog(
					city, diarogLayer, 30, 30, 350, 100 );
			}
		}
	}

}

/**
 * RҐ_CAÔ߂PanelB
 */
class MakeArmyDialog extends JPanel
					implements UnitListener, CreatureStorableListener {

	City city;

	AbstractTableModel armysTableModel;
	JTable table;
	final static String[] columnNames = { "O", "m", "n̐", "|̐" };
	final static Object[] columnTemplate = { "name",
									new Integer(0), new Integer(0), new Integer(0) };
	JLabel	citysWeapons;	// ss̕(͕m)
	JLabel	armysWeapons;	// R̕(͕m)

	JSlider weaponsSlider;

	public MakeArmyDialog(City city) {
		this.city = city;
		armysTableModel = new ArmysTableModel();

		// R\p̃e[upl̍쐬B
		//table = new JTable( makeTableDataOfArmys(), columnNames );
		table = new JTable( armysTableModel );
		table.setPreferredScrollableViewportSize( new Dimension(500, 70) );
		JScrollPane tablePanel = new JScrollPane( table );

		table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		ListSelectionModel rowSM = table.getSelectionModel();
		rowSM.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				if (e.getValueIsAdjusting()) return;

				ListSelectionModel lsm = (ListSelectionModel)e.getSource();
				if (lsm.isSelectionEmpty()) {

				}
				else {
					Army army;
					Object[] armys;
					synchronized(MakeArmyDialog.this.city) {
						armys =
							MakeArmyDialog.this.city.getArmyCollection().toArray();
					}

					int selectionIndex = lsm.getMinSelectionIndex();
					if ( armys.length > selectionIndex ) {
						army = (Army)armys[selectionIndex];
						UnitControllerApplicationQuarter.getInstance().setCapturedCreature(army);

						//UnitController cont = UnitControllerApplicationQuarter.getInstance()
						//cont.setComponent(MakeArmyDialog.this);
						//cont.setComponentX(0);
						//cont.setComponentY(0);
						//army.clicked(cont);
					}
				}
			}
		});


		// mEӂ킯XC_[̍쐬B
		JPanel sliderPanel = new JPanel();
		citysWeapons = new JLabel("100", SwingConstants.CENTER);
		armysWeapons = new JLabel("0", SwingConstants.CENTER);


		// Elӂ킯XC_[̍쐬B
		weaponsSlider = new JSlider(0,100, 50);
		weaponsSlider.setInverted(true);
		//weaponsSlider.addChangeListener( listener );

		sliderPanel.setLayout( new FlowLayout() );
		sliderPanel.add(citysWeapons);
		sliderPanel.add(weaponsSlider);
		sliderPanel.add(armysWeapons);

		//setLayout( new GridLayout(2, 1) );
		//add(tablePanel);
		//add(sliderPanel);

		setLayout( new BorderLayout() );
		add( "Center", tablePanel );
		add( "South", sliderPanel );

		city.addUnitListener(this);
		city.addCreatureStorableListener(this);
	}

	/**
	 * `悷MakeArmyDialog̃f[^ŐV̏Ԃɂ郁\bhB
	 */
	void updateData() {

	}

	public void stateChanged(UnitEvent unitEvent) {
		if (unitEvent.getSource() instanceof Army) {
			Army eventSourceA = (Army)unitEvent.getSource();
			int x = 0;

			synchronized(city) {
				Collection armys = city.getArmyCollection();
				Iterator iterator = armys.iterator();

				while ( iterator.hasNext() ) {
					if ( eventSourceA == (Army)(iterator.next()) ) {
						armysTableModel.fireTableRowsUpdated(x,x);
						break;
					}
					x++;
				}
			}
		}
		repaint();
	}

	public void creatureAdded(CreatureStorableEvent event) {
		armysTableModel.fireTableRowsInserted( armysTableModel.getRowCount(), armysTableModel.getRowCount() );
		repaint();
	}

	public void creatureRemoved(CreatureStorableEvent event) {
		armysTableModel.fireTableRowsDeleted( 0, armysTableModel.getRowCount() );
		repaint();
	}

	public void moved(UnitEvent unitEvent) {
		armysTableModel.fireTableRowsInserted( 0, armysTableModel.getRowCount() );
		repaint();
	}

	public Object[][] makeTableDataOfArmys() {

		Collection armys = city.getArmyCollection();
		int rowNumber = armys.size();

		Object[][] data = new Object[rowNumber][4];

		Army army;
		Iterator iterator = armys.iterator();

		for ( int x = 0; x < rowNumber && iterator.hasNext(); x++ ) {
			army = (Army)(iterator.next());

			data[x][0] = army.getName();
			data[x][1] = new Integer( army.getNumberOfSoldier() );
			data[x][2] = new Integer( army.getNumberOfHorse() );
			data[x][3] = new Integer( army.getNumberOfArchery() );
		}

		return data;
	}


	class ArmysTableModel extends AbstractTableModel {


		public int getColumnCount() {
			return columnNames.length;
		}

		public int getRowCount() {
			return city.getArmyCollection().size();
		}

		public String getColumnName(int col) {
			return columnNames[col];
		}

		public Object getValueAt(int row, int col) {
			Object[] armys;
			Army army;
			Object retObject;

			synchronized(city) {
				armys = city.getArmyCollection().toArray();
			}

			if ( armys.length > row ) {
				army = (Army) armys[row];
			}
			else {
				return null;
			}


			switch (col) {
				case 0:
					retObject = army.getName();
					break;
				case 1:
					retObject = new Integer( army.getNumberOfSoldier() );
					break;
				case 2:
					retObject = new Integer( army.getNumberOfHorse() );
					break;
				case 3:
					retObject = new Integer( army.getNumberOfArchery() );
					break;
				default:
					retObject = army.getName();
					break;
			}
			return retObject;
		}

		public Class getColumnClass(int col) {
			return columnTemplate[col].getClass();
			//return getValueAt(0, col).getClass();
			//return columnClasses[col];
		}

	}


}

/**
 * Elӂ킯_CAÔ߂PanelB
 */
class ArtisanPercentDialog extends JPanel {

	City city;

	JLabel	weapon;		// p̐
	JLabel	archery;	// |̐B

	JSlider artisanSlider;

	static Icon weaponIcon;
	static Icon archeryIcon;

	public ArtisanPercentDialog(City city) {
		DialogListener listener = new DialogListener();
		this.city = city;

		// NX[_[ƁAToolKit̎擾B
		ClassLoader cl = this.getClass().getClassLoader();

		// NX[_[𗘗pgift@C̃oCif[^ǂ݂݁A
		// Toolkig𗘗pāÃoCif[^ƂImageIuWFNg쐬B
		weaponIcon = new ImageIcon(cl.getResource("resources/weapon.gif"));
		archeryIcon = new ImageIcon(cl.getResource("resources/archery.gif"));


		weapon = new JLabel("", weaponIcon, SwingConstants.CENTER);
		archery = new JLabel("", archeryIcon, SwingConstants.CENTER);


		// Elӂ킯XC_[̍쐬B
		artisanSlider = new JSlider(0,100, city.getArcheryProductPercent());
		artisanSlider.setInverted(true);
		artisanSlider.addChangeListener( listener );

		JPanel sliderPanel = new JPanel();	// mn|Ȃǂ̐U蕪̂߂Panel
		JPanel okPanel = new JPanel();	// OKCANCEL{^Ȃǂ͂Panel

		setLayout( new BorderLayout() );
		add( "Center", sliderPanel );
		//setLayout( new GridLayout(2, 1) );
		//add(sliderPanel);
		//add(okPanel);

		sliderPanel.setLayout( new FlowLayout() );
		sliderPanel.add(weapon);
		sliderPanel.add(artisanSlider);
		sliderPanel.add(archery);

		updateData();
	}

	/**
	 * `悷Dialog̃f[^ŐV̏Ԃɂ郁\bhB
	 */
	void updateData() {

		// Elӂ킯XC_[B
		artisanSlider.setValue( city.getArcheryProductPercent() );

		weapon.setText( new Integer( artisanSlider.getMaximum() - artisanSlider.getValue() ).toString() );
		archery.setText( new Integer( artisanSlider.getValue() ).toString() );
	}

	public void update(Graphics g) {
		paint(g);
	}

	public void paint(Graphics g) {
		updateData();
		super.paint(g);
	}
	class DialogListener implements ChangeListener, ActionListener {
		public void stateChanged(ChangeEvent e) {
			JSlider slider = (JSlider)e.getSource();

			weapon.setText( new Integer( slider.getMaximum() - slider.getValue() ).toString() );
			archery.setText( new Integer( slider.getValue() ).toString() );

			city.setArcheryProductPercent( slider.getValue() );
		}
		public void actionPerformed(ActionEvent e) {
			if ( e.getActionCommand().equals("makeArmy") ) {
				// R𐶐B
				city.makeArmy(5000);
			}
		}
	}
}

