/**
 * JavaWebStartΉ̎OuQ[B
 */
package tk.mtantyukityuki.threeKingdoms.view.swing;

import tk.mtantyukityuki.threeKingdoms.model.*;
import tk.mtantyukityuki.threeKingdoms.unit.*;
import tk.mtantyukityuki.threeKingdoms.unit.controller.*;
import tk.mtantyukityuki.threeKingdoms.unit.graphicsEngine.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

import javax.swing.plaf.metal.DefaultMetalTheme;
import javax.swing.plaf.metal.MetalLookAndFeel;

public class ThreeKingdoms extends JFrame {


	private JToolBar toolbar;
	private JMenuBar menubar;
	private ButtonGroup lafMenuGroup = new ButtonGroup();
	private ThreeKingdomsToolBarListener toolbarListener;

	// Possible Look & Feels
	private String mac      = "com.sun.java.swing.plaf.mac.MacLookAndFeel";
	private String metal    = "javax.swing.plaf.metal.MetalLookAndFeel";
	private String motif    = "com.sun.java.swing.plaf.motif.MotifLookAndFeel";
	private String windows  = "com.sun.java.swing.plaf.windows.WindowsLookAndFeel";

	// The current Look & Feel
	private String currentLookAndFeel = metal;


	static JDesktopPane desktop = new JDesktopPane();
	static WindowsManager windowsManager = WindowsManager.getInstance();

	Integer mapLayer = new Integer(1);

	int MAP_FRAME_X = 0;
	int MAP_FRAME_Y = 0;

	int MAP_FRAME_WIDTH = 300;
	int MAP_FRAME_HEIGHT = 300;

	MediaTracker mediaTracker;

	UnitGraphicsEngine uge;

	// 嗤
	Board chinasContinental;

	// Q[̎ԐݒB(234N,8,24, EGCg300b)
	Time time = Time.getInstance(234, 8, 24, 300);


	public ThreeKingdoms(String s) {
		super(s);

		mediaTracker = new MediaTracker( this );
		uge = UnitGraphicsEngineApplicationQuarter.getInstance( mediaTracker, this );

		// NX[_[ƁAToolKit̎擾B
		ClassLoader cl = this.getClass().getClassLoader();
		Toolkit tk = Toolkit.getDefaultToolkit();

		// NX[_[𗘗pgift@C̃oCif[^ǂ݂݁A
		// Toolkit𗘗pāÃoCif[^ƂImageIuWFNg쐬A
		// 쐬ꂽImageIuWFNg̃AṽACRɐݒ肷B
		setIconImage( tk.createImage( cl.getResource("resources/map.gif") ) );

		Container pane = getContentPane();
		pane.setLayout( new BorderLayout() );


		/*
		 * c[o[Ej[o[AẴXi𐶐B
		 */

		// c[o[\t邽߂menuPanel쐬B
		JPanel menuPanel = new JPanel();
		menuPanel.setLayout( new BorderLayout() );

		// menuPanelt[ɑB
		pane.add( menuPanel, "North" );
		menuPanel.add( createPanelSppedAdjust(), "Center" );


		// c[o[Ej[o[p̃Xi̐B
		toolbarListener = new ThreeKingdomsToolBarListener();


		// j[o[̐B
		menuPanel.add( "North", createMenubar() );

		// c[o[ƃc[o[p̃pl𐶐B
		JPanel toolPanel = new JPanel();
		toolPanel.setLayout( new BorderLayout() );
		toolPanel.add( "Center", createToolbar() );

		// c[o[c[o[p̃plmenuPanelɓ\tB
		menuPanel.add( "South", toolPanel );


		/*
		 * C^[it[`悷邽߂̃Xy[X̍쐬B
		 */

		// desktopt[ɑB
		pane.add( "Center", desktop );


		createContinental();

		createMap( mapLayer, MAP_FRAME_X, MAP_FRAME_Y,  MAP_FRAME_WIDTH, MAP_FRAME_HEIGHT);
		chinasContinental.startAllUnit();

	}

	public static JDesktopPane getDesktop() {
		if ( desktop == null ) {
			desktop = new JDesktopPane();
		}
		return desktop;
	}

	public void createContinental() {
		chinasContinental = new Board(16, 16, time);

		for ( int x = 0; x < 16; x++ ) {
		 for ( int y = 0; y < 16; y++ ) {
			chinasContinental.setGround( x, y, new Ground( x, y, chinasContinental, 0 ) );
		 }
		}

		chinasContinental.setGround( 1, 0, new Slope( 1, 0, chinasContinental, new Direction(0), 0 ) );
		chinasContinental.setGround( 2, 0, new Slope( 2, 0, chinasContinental, new Direction(1), 0 ) );
		chinasContinental.setGround( 2, 1, new Slope( 2, 1, chinasContinental, new Direction(2), 0 ) );
		chinasContinental.setGround( 2, 2, new Slope( 2, 2, chinasContinental, new Direction(3), 0 ) );
		chinasContinental.setGround( 1, 2, new Slope( 1, 2, chinasContinental, new Direction(4), 0 ) );
		chinasContinental.setGround( 0, 2, new Slope( 0, 2, chinasContinental, new Direction(5), 0 ) );
		chinasContinental.setGround( 0, 1, new Slope( 0, 1, chinasContinental, new Direction(6), 0 ) );
		chinasContinental.setGround( 0, 0, new Slope( 0, 0, chinasContinental, new Direction(7), 0 ) );

		chinasContinental.setGround( 1, 3, new Slope( 1, 3, chinasContinental, new Direction(0), 0 ) );
		chinasContinental.setGround( 2, 3, new Slope( 2, 3, chinasContinental, new Direction(1), 0 ) );
		chinasContinental.setGround( 2, 4, new Slope( 2, 4, chinasContinental, new Direction(2), 0 ) );
		chinasContinental.setGround( 2, 5, new Slope( 2, 5, chinasContinental, new Direction(3), 0 ) );
		chinasContinental.setGround( 1, 5, new Slope( 1, 5, chinasContinental, new Direction(4), 0 ) );
		chinasContinental.setGround( 0, 5, new Slope( 0, 5, chinasContinental, new Direction(5), 0 ) );
		chinasContinental.setGround( 0, 4, new Slope( 0, 4, chinasContinental, new Direction(6), 0 ) );
		chinasContinental.setGround( 0, 3, new Slope( 0, 3, chinasContinental, new Direction(7), 0 ) );
		chinasContinental.setGround( 1, 4, new Ground( 1, 4, chinasContinental, 1 ) );

		chinasContinental.setGround( 4, 1, new Slope( 4, 1, chinasContinental, new Direction(7), 0 ) );
		chinasContinental.setGround( 5, 1, new Slope( 5, 1, chinasContinental, new Direction(1), 0 ) );
		chinasContinental.setGround( 4, 2, new Slope( 4, 2, chinasContinental, new Direction(5), 0 ) );
		chinasContinental.setGround( 5, 2, new Slope( 5, 2, chinasContinental, new Direction(3), 0 ) );

		for ( int x = 0; x < 16; x++ ) {
			chinasContinental.setGround( x, 6, new Ground( x, 6, chinasContinental, -3 ) );
		}

		Commander commander0 = new Commander(0, 0, null, null, 1, null, false);
		Commander commander1 = new Commander(0, 0, null, null, 1, null, false);
		Commander commander2 = new Commander(0, 0, null, null, 1, null, false);
		Commander commander3 = new Commander(0, 0, null, null, 1, null, false);
		Commander commander4 = new Commander(0, 0, null, null, 1, null, false);
		Commander commander5 = new Commander(0, 0, null, null, 1, null, false);
		Commander commander6 = new Commander(0, 0, null, null, 1, null, false);
		Commander commander7 = new Commander(0, 0, null, null, 1, null, false);
		Commander commander8 = new Commander(0, 0, null, null, 1, null, false);
		Commander commander9 = new Commander(0, 0, null, null, 1, null, false);
		Commander commander10 = new Commander(0, 0, null, null, 1, null, false);

		Army infantry0 = new Army(14, 0, chinasContinental, new Direction( Direction.UP ), 1,
					Army.NORMAL, chinasContinental.getGround(14, 0), true, commander0);
		Army infantry1 = new Army(13, 0, chinasContinental, new Direction( Direction.LEFT ), 1,
					Army.NORMAL, infantry0, true, commander1);
		Army infantry2 = new Army(12, 0, chinasContinental, new Direction( Direction.UP ), 1,
					Army.NORMAL, infantry1, true, commander2);
		Army infantry3 = new Army(11, 1, chinasContinental, new Direction( Direction.LEFT ), 1,
					Army.NORMAL, infantry2, true, commander3);
		Army infantry4 = new Army(11, 2, chinasContinental, new Direction( Direction.UP ), 1,
					Army.NORMAL, infantry3, true, commander4);
		Army infantry5 = new Army(11, 3, chinasContinental, new Direction( Direction.LEFT ), 1,
					Army.NORMAL, infantry4, true, commander5);
		Army infantry6 = new Army(12, 4, chinasContinental, new Direction( Direction.UP ), 1,
					Army.NORMAL, infantry5, true, commander6);
		Army infantry7 = new Army(13, 4, chinasContinental, new Direction( Direction.LEFT ), 1,
					Army.NORMAL, infantry6, true, commander7);
		Army infantry8 = new Army(14, 4, chinasContinental, new Direction( Direction.UP ), 1,
					Army.NORMAL, infantry7, true, commander8);
		Army infantry9 = new Army(15, 3, chinasContinental, new Direction( Direction.LEFT ), 1,
					Army.NORMAL, infantry8, true, commander9);
		Army infantry10 = new Army(15, 2, chinasContinental, new Direction( Direction.UP ), 1,
					Army.NORMAL, infantry9, true, commander10);
		infantry0.setTarget( infantry10 );


		commander0.setArmy( infantry0 );
		commander1.setArmy( infantry1 );
		commander2.setArmy( infantry2 );
		commander3.setArmy( infantry3 );
		commander4.setArmy( infantry4 );
		commander5.setArmy( infantry5 );
		commander6.setArmy( infantry6 );
		commander7.setArmy( infantry7 );
		commander8.setArmy( infantry8 );
		commander9.setArmy( infantry9 );
		commander10.setArmy( infantry10 );

		chinasContinental.firstSetCreature(infantry0.getX(), infantry0.getY(), infantry0);
		chinasContinental.firstSetCreature(infantry1.getX(), infantry1.getY(), infantry1);
		chinasContinental.firstSetCreature(infantry2.getX(), infantry2.getY(), infantry2);
		chinasContinental.firstSetCreature(infantry3.getX(), infantry3.getY(), infantry3);
		chinasContinental.firstSetCreature(infantry4.getX(), infantry4.getY(), infantry4);
		chinasContinental.firstSetCreature(infantry5.getX(), infantry5.getY(), infantry5);
		chinasContinental.firstSetCreature(infantry6.getX(), infantry6.getY(), infantry6);
		chinasContinental.firstSetCreature(infantry7.getX(), infantry7.getY(), infantry7);
		chinasContinental.firstSetCreature(infantry8.getX(), infantry8.getY(), infantry8);
		chinasContinental.firstSetCreature(infantry9.getX(), infantry9.getY(), infantry9);
		chinasContinental.firstSetCreature(infantry10.getX(), infantry10.getY(), infantry10);

		// sš݁B
		City city = new City(15, 15,  chinasContinental, new Direction( Direction.UP ), 0);
		chinasContinental.firstSetStructure(15,15, city);

		// Xт̐ݒuB
		Forest forest = new Forest(14, 15,  chinasContinental, 100, 0);
		chinasContinental.firstSetStructure(14,15, forest);
		forest = new Forest(13, 15,  chinasContinental, 100, 1);
		chinasContinental.firstSetStructure(13,15, forest);

		// _n̐ݒuB
		Farm farm = new Farm(14, 14,  chinasContinental, 100, 0);
		chinasContinental.firstSetStructure(14,14, farm);
	}

	public JMenuBar createMenubar() {
		menubar = new JMenuBar();

		JMenuItem mi;

		menubar.getAccessibleContext().setAccessibleName( "MenuBar.accessible_description" );


		// ***** create laf switcher menu
		JMenu lafMenu = (JMenu) menubar.add( new JMenu( "Look & Feel" ) );
			lafMenu.setMnemonic( KeyEvent.VK_L );
		lafMenu.getAccessibleContext().setAccessibleDescription( "LafMenu.laf_accessible_description" );

		mi = createLafMenuItem(lafMenu, "Java", KeyEvent.VK_J,
			   "LafMenu.java_accessible_description", metal);
		mi.setSelected(true); // this is the default l&f

		createLafMenuItem(lafMenu, "Macintosh", KeyEvent.VK_M,
			   "LafMenu.mac_accessible_description", mac);

		createLafMenuItem(lafMenu, "Motif", KeyEvent.VK_F,
			   "LafMenu.motif_accessible_description", motif);

		createLafMenuItem(lafMenu, "Windows", KeyEvent.VK_W,
			   "LafMenu.windows_accessible_description", windows);

		return menubar;
	}

	/**
	 * Creates a JRadioButtonMenuItem for the Look and Feel menu
	 */
	public JMenuItem createLafMenuItem( JMenu menu, String label, int mnemonic,
						String accessibleDescription, String laf ) {

		JMenuItem mi = (JRadioButtonMenuItem) menu.add( new JRadioButtonMenuItem( label ) );
		lafMenuGroup.add(mi);
		mi.setMnemonic( mnemonic );
		mi.getAccessibleContext().setAccessibleDescription( "accessibleDescription" );
		mi.addActionListener(new ChangeLookAndFeelAction(this, laf));

		mi.setEnabled(isAvailableLookAndFeel(laf));

		return mi;
	}

	/**
	 * Stores the current L&F, and calls updateLookAndFeel, below
	 */
	public void setLookAndFeel(String laf) {
		if(currentLookAndFeel != laf) {
			currentLookAndFeel = laf;
			updateLookAndFeel();
		}
	}

	/**
	 * Sets the current L&F on each demo module
	 */
	public void updateLookAndFeel() {

		try {
			UIManager.setLookAndFeel(currentLookAndFeel);
			SwingUtilities.updateComponentTreeUI(this);
		}
		catch (Exception ex) {
			System.out.println("Failed loading L&F: " + currentLookAndFeel);
			System.out.println(ex);
		}

	}

 protected boolean isAvailableLookAndFeel(String laf) {
		 try {
			 Class lnfClass = Class.forName(laf);
			 LookAndFeel newLAF = (LookAndFeel)(lnfClass.newInstance());
			 return newLAF.isSupportedLookAndFeel();
		 } catch(Exception e) { // If ANYTHING weird happens, return false
			 return false;
		 }
	 }






	private Component createToolbar() {
		toolbar = new JToolBar();

		JButton b;

		/*
		 * NX[_[g resourcestH_̃t@Cǂ݂݁A
		 * c[o[̃ACR쐬B
		 */

		// NX[_[̎擾B
		ClassLoader cl = this.getClass().getClassLoader();

		b = new JButton( new ImageIcon( cl.getResource( "resources/uma.gif" ) ) ) {
			public float getAlignmentY() { return 2; }
		};
		b.setRequestFocusEnabled(false);
		b.setMargin(new Insets(1,1,1,1));

		b.setToolTipText("sR}bv");
		b.addActionListener( toolbarListener );
		b.setActionCommand("showStrategyMap");
		b.setMnemonic( KeyEvent.VK_S );

		toolbar.add(b);

		toolbar.add(Box.createHorizontalGlue());
		return toolbar;
	}

	public JInternalFrame createMap( Integer layer, int x, int y, int width, int height ) {

		JInternalFrame internalFrame =
			windowsManager.createMapWindow(
				chinasContinental, layer, x,y, width, height
			);

		return internalFrame;

	}

	private JPanel createPanelSppedAdjust() {
		return new TimeViewer();
	}

	/** c[o[p̃Xi[B */
	class ThreeKingdomsToolBarListener implements ActionListener {

		public void actionPerformed(ActionEvent e) {
			if ( e.getActionCommand().equals("showStrategyMap") ) {
				//sR}bvJB
				createMap( new Integer(1), 10, 10, 200, 200);
			}
		}
	}

	public static void main( String argv[] ) {

		JFrame frame = new ThreeKingdoms("Ou");
		frame.setDefaultCloseOperation( EXIT_ON_CLOSE );

		frame.pack();

		// t[̉Əc̃TCYݒB
		frame.setSize( 500, 500 );

		// t[\悤ɐݒB(falseɂƕ\ȂȂB)
		frame.setVisible( true );
	}

}


